package main

// #cgo CFLAGS: -I../../ts3client-pluginsdk/include -I../c
// #cgo LDFLAGS: -Wl,-unresolved-symbols=ignore-all
// #include <stdlib.h>
// #include "teamspeak/public_errors.h"
// #include "teamspeak/public_errors_rare.h"
// #include "teamspeak/public_definitions.h"
// #include "teamspeak/public_rare_definitions.h"
// #include "teamspeak/clientlib_publicdefinitions.h"
// #include "plugin_definitions.h"
// #include "ts3FunctionsWrapper.h"
import "C"
import (
	tsgo "./tsgo"
)

func main() {} // Required if you want to export functions

/*
	Required functions.
*/

//export GoTs3pluginName
func GoTs3pluginName() *C.char {
	return C.CString(tsgo.PluginName)
}

//export GoTs3pluginVersion
func GoTs3pluginVersion() *C.char {
	return C.CString(tsgo.PluginVersion)
}

//export GoTs3pluginAPIVersion
func GoTs3pluginAPIVersion() C.int {
	return C.int(23)
}

//export GoTs3pluginAuthor
func GoTs3pluginAuthor() *C.char {
	return C.CString(tsgo.PluginAuthor)
}

//export GoTs3pluginDescription
func GoTs3pluginDescription() *C.char {
	return C.CString(tsgo.PluginDescription)
}

//export GoTs3pluginInit
func GoTs3pluginInit() C.int {
	tsgo.Ts3Functions = tsgo.Ts3FunctionsStruct{
		PrintMessage: ts3FncPrintMessage,
	}

	return C.int(tsgo.Ts3pluginInit())
}

//export GoTs3pluginShutdown
func GoTs3pluginShutdown() {
	tsgo.Ts3pluginShutdown()
}

/*
	Not so required functions
*/

//export GoTs3onClientPokeEvent
func GoTs3onClientPokeEvent(serverConnectionHandlerID C.uint64, fromClientID C.anyID, pokerName *C.char, pokerUniqueIdentity *C.char, message *C.char, ffIgnored C.int) C.int {
	return C.int(tsgo.Ts3onClientPokeEvent(uint64(serverConnectionHandlerID), tsgo.AnyId(fromClientID), C.GoString(pokerName), C.GoString(pokerUniqueIdentity), C.GoString(message), int(ffIgnored)))
}

/*
	Ts3 Function wrapper
*/

func ts3FncPrintMessage(serverConnectionHandlerID uint64, message string, messageTarget tsgo.PluginMessageTarget) {
	switch messageTarget {
	case tsgo.PLUGIN_MESSAGE_TARGET_CHANNEL:
		C.Ts3FncPrintMessage(C.uint64(serverConnectionHandlerID), C.CString(message), C.PLUGIN_MESSAGE_TARGET_CHANNEL)
	case tsgo.PLUGIN_MESSAGE_TARGET_SERVER:
		C.Ts3FncPrintMessage(C.uint64(serverConnectionHandlerID), C.CString(message), C.PLUGIN_MESSAGE_TARGET_SERVER)
	}
}
